Index: trunk/XTIDE_Universal_BIOS/Inc/IdeRegisters.inc
===================================================================
--- trunk/XTIDE_Universal_BIOS/Inc/IdeRegisters.inc	(revision 379)
+++ trunk/XTIDE_Universal_BIOS/Inc/IdeRegisters.inc	(revision 380)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,9 +10,9 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 ;
@@ -97,4 +97,5 @@
 COMMAND_IDENTIFY_DEVICE					EQU		0ECh
 COMMAND_SET_FEATURES					EQU		0EFh
+COMMAND_IDLE							EQU		0E3h
 
 
@@ -102,5 +103,5 @@
 FEATURE_ENABLE_WRITE_CACHE				EQU		02h
 FEATURE_DISABLE_WRITE_CACHE				EQU		82h		; Can also be used to flush cache
-FEATURE_SET_TRANSFER_MODE				EQU		03h		; Transfe mode goes to the Sector Count Register
+FEATURE_SET_TRANSFER_MODE				EQU		03h		; Transfer mode goes to the Sector Count Register
 	PIO_DEFAULT_MODE					EQU		0h
 	PIO_DEFAULT_MODE_DISABLE_IORDY		EQU		1h
Index: trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc
===================================================================
--- trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 379)
+++ trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 380)
@@ -4,5 +4,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -11,9 +11,9 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 ;
@@ -40,4 +40,5 @@
 	.bMinFddCnt			resb	1	; Minimum number of Floppy Drives
 	.bStealSize			resb	1	; Number of 1kB blocks stolen from 640kB base RAM
+	.bIdleTimeout		resb	1	; Standby timer value
 
 	.ideVarsBegin:
Index: trunk/XTIDE_Universal_BIOS/Src/Main.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 379)
+++ trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 380)
@@ -14,5 +14,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -21,9 +21,9 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 ;
@@ -114,4 +114,5 @@
 	at	ROMVARS.bMinFddCnt, 	db	0						; Do not force minimum number of floppy drives
 	at	ROMVARS.bStealSize,		db	1						; Steal 1kB from base memory
+	at	ROMVARS.bIdleTimeout,	db	0						; Standby timer disabled by default
 
 	at	ROMVARS.ideVars0+IDEVARS.wPort,			dw	DEVICE_ATA_DEFAULT_PORT 		; Controller Command Block base port
@@ -157,4 +158,5 @@
 	at	ROMVARS.bMinFddCnt, 	db	1						; Assume at least 1 floppy drive present if autodetect fails
 	at	ROMVARS.bStealSize,		db	1						; Steal 1kB from base memory in full mode
+	at	ROMVARS.bIdleTimeout,	db	0						; Standby timer disabled by default
 
 	at	ROMVARS.ideVars0+IDEVARS.wPort,			dw	DEVICE_XTIDE_DEFAULT_PORT			; Controller Command Block base port
@@ -184,10 +186,10 @@
 iend
 
-	; Strings are first to avoid them moving unnessarily when code is turned on and off with %ifdef's
+	; Strings are first to avoid them moving unnecessarily when code is turned on and off with %ifdef's
 	; since some groups of strings need to be on the same 256-byte page.
 	;
 %ifdef MODULE_STRINGS_COMPRESSED
 	%define STRINGSCOMPRESSED_STRINGS
-	%include "StringsCompressed.asm" 
+	%include "StringsCompressed.asm"
 %else
 	%include "Strings.asm"			; For BIOS message strings
@@ -199,12 +201,12 @@
 
 	; String compression tables need to come after the AssemblyLibrary (since they depend on addresses
-	; established in the assembly library), and are unncessary if strings are not compressed.
+	; established in the assembly library), and are unnecessary if strings are not compressed.
 	;
 %ifdef MODULE_STRINGS_COMPRESSED
-	%undef  STRINGSCOMPRESSED_STRINGS		
+	%undef  STRINGSCOMPRESSED_STRINGS
 	%define STRINGSCOMPRESSED_TABLES
 	%include "StringsCompressed.asm"
 %endif
-		
+
 	%include "Initialize.asm"		; For BIOS initialization
 	%include "Interrupts.asm"		; For Interrupt initialization
Index: trunk/XTIDE_Universal_BIOS/makefile
===================================================================
--- trunk/XTIDE_Universal_BIOS/makefile	(revision 379)
+++ trunk/XTIDE_Universal_BIOS/makefile	(revision 380)
@@ -8,5 +8,5 @@
 # clean		Removes all files from \Build                                                        #
 # checksum*	Builds all and then generates checksum byte to all binary files                      #
-# strings*	Compress src\strings.asm to src\StringsCompressed.asm                                #
+# strings*	Compress src\Strings.asm to src\StringsCompressed.asm                                #
 #                                                                                                #
 # * at the end of target name means that Perl is required for the job.                           #
@@ -16,13 +16,13 @@
 # Following modules can be included or excluded:                                                 #
 # MODULE_ADVANCED_ATA       Native support for some VLB IDE controllers                          #
-# MODULE_BOOT_MENU          Boot Menu for selection drive to boot from                           #
-# MODULE_EBIOS              Enhanced functions for access drives over 8.4 GB                     #
+# MODULE_BOOT_MENU          Boot Menu for selection of drive to boot from                        #
+# MODULE_EBIOS              Enhanced functions for accessing drives over 8.4 GB                  #
 # MODULE_JRIDE              Support for JR-IDE/ISA                                               #
 # MODULE_SERIAL             Virtual hard disks using serial port                                 #
-# MODULE_SERIAL_FLOPPY      Virtual floppy drives using serial port                              #
-# MODULE_STRINGS_COMPRESSED Compressed strings to save space                                     #
+# MODULE_SERIAL_FLOPPY      Virtual floppy drives using serial port (requires MODULE_SERIAL)     #
+# MODULE_STRINGS_COMPRESSED Use compressed strings to save space                                 #
 #                                                                                                #
 # Not modules but these affect the assembly:                                                     #
-# ELIMINATE_CGA_SNOW        Prevents CGA snowing at the cost of few bytes                        #
+# ELIMINATE_CGA_SNOW        Prevents CGA snowing at the cost of a few bytes                      #
 # USE_186                   Use instructions supported by 80188/80186 and V20/V30 and later      #
 # USE_286                   Use instructions supported by 286 and later                          #
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/ConfigurationMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/ConfigurationMenu.asm	(revision 379)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/ConfigurationMenu.asm	(revision 380)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,11 +10,11 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
-;		
+;
 
 ; Section containing initialized data
@@ -26,5 +26,5 @@
 	at	MENUPAGE.fnEnter,			dw	ConfigurationMenu_EnterMenuOrModifyItemVisibility
 	at	MENUPAGE.fnBack,			dw	MainMenu_EnterMenuOrModifyItemVisibility
-	at	MENUPAGE.wMenuitems,		dw	9
+	at	MENUPAGE.wMenuitems,		dw	10
 iend
 
@@ -135,4 +135,37 @@
 iend
 
+g_MenuitemConfigurationIdleTimeout:
+istruc MENUITEM
+	at	MENUITEM.fnActivate,		dw	Menuitem_ActivateMultichoiceSelectionForMenuitemInDSSI
+	at	MENUITEM.fnFormatValue,		dw	MenuitemPrint_WriteLookupValueStringToBufferInESDIfromRawItemInDSSI
+	at	MENUITEM.szName,			dw	g_szItemCfgIdleTimeout
+	at	MENUITEM.szQuickInfo,		dw	g_szNfoCfgIdleTimeout
+	at	MENUITEM.szHelp,			dw	g_szHelpCfgIdleTimeout
+	at	MENUITEM.bFlags,			db	FLG_MENUITEM_VISIBLE | FLG_MENUITEM_BYTEVALUE | FLG_MENUITEM_CHOICESTRINGS
+	at	MENUITEM.bType,				db	TYPE_MENUITEM_MULTICHOICE
+	at	MENUITEM.itemValue + ITEM_VALUE.wRomvarsValueOffset,		dw	ROMVARS.bIdleTimeout
+	at	MENUITEM.itemValue + ITEM_VALUE.szDialogTitle,				dw	g_szDlgCfgIdleTimeout
+	at	MENUITEM.itemValue + ITEM_VALUE.szMultichoice,				dw	g_szMultichoiceIdleTimeout
+	at	MENUITEM.itemValue + ITEM_VALUE.rgwChoiceToValueLookup,		dw	g_rgwChoiceToValueLookupForIdleTimeout
+	at	MENUITEM.itemValue + ITEM_VALUE.rgszChoiceToStringLookup,	dw	g_rgszChoiceToStringLookupForIdleTimeout
+iend
+
+g_rgwChoiceToValueLookupForIdleTimeout:
+	%assign i -12
+	%rep 21
+		%assign i i+12
+		dw	i		; i / 12 = 0 (disabled) or 1...20 minutes
+	%endrep
+	%rep 4
+		%assign i i+1
+		dw	i		; 241...244 = (i - 240) * 30 minutes
+	%endrep
+g_rgszChoiceToStringLookupForIdleTimeout:
+	%assign i 0
+	%rep 25
+		dw	g_szIdleTimeoutChoice%[i]
+		%assign i i+1
+	%endrep
+	;	dw	NULL	; Is this needed? *FIXME*
 
 ; Section containing code
@@ -297,6 +330,6 @@
 ; ConfigurationMenu_CheckAndMoveSerialDrivesToBottom
 ;
-; Checks to ensure that serial adapters are at the end of the 
-; IDEVARS structures list, as serial floppies (if present) need to be 
+; Checks to ensure that serial adapters are at the end of the
+; IDEVARS structures list, as serial floppies (if present) need to be
 ; the last drives detected by the BIOS.  If there are other controllers
 ; after a serial controller, the other controllers are moved up on the list
@@ -309,6 +342,6 @@
 ;	Corrupts registers:
 ;		All
-;----------------------------------------------------------------------		
-ConfigurationMenu_CheckAndMoveSerialDrivesToBottom:		
+;----------------------------------------------------------------------
+ConfigurationMenu_CheckAndMoveSerialDrivesToBottom:
 	push	es
 	push	ds
@@ -319,10 +352,9 @@
 	push	es
 	pop		ds
-	mov		ch, 0						; clearing high order of CX and notification flag 
-	mov		dx, cx						; (probably unncessary, CX should be less than 127, but just to be sure)
-	jcxz	.done						; probably unnecessary, but make sure there is at least one controller		
-
-	add		di, ROMVARS.ideVars0		; add in offset of first idevars
-	mov		bx, di
+	xor		ch, ch						; clearing high order of CX and notification flag
+	mov		dx, cx						; (probably unnecessary, CX should be less than 127, but just to be sure)
+	jcxz	.done						; probably unnecessary, but make sure there is at least one controller
+
+	lea		bx, [di+ROMVARS.ideVars0]	; add in offset of first idevars
 
 .outerLoop:
@@ -331,5 +363,5 @@
 	xor		ax, ax						; first non-serial found
 	mov		cl, dl						; idevars count
-	mov		ch, 0
+	xor		ch, ch
 
 .loop:
@@ -337,6 +369,6 @@
 	jnz		.notSerial
 
-	test	si, si						; record the first serial controllert that we find
-	jnz		.next	
+	test	si, si						; record the first serial controller that we find
+	jnz		.next
 	mov		si, di
 	jmp		.next
@@ -345,12 +377,12 @@
 	mov		ax, di						; record the *last* non-serial controller that we find
 
-.next:	
+.next:
 	add		di, IDEVARS_size
 	loop	.loop
 
-	test	si,si						; no serial drives, nothing to do
+	test	si, si						; no serial drives, nothing to do
 	jz		.done
-	cmp		si,ax						; serial port is already later on the list than any other controllers
-	ja		.done						; (also takes care of the case where ther are no other controllers)
+	cmp		si, ax						; serial port is already later on the list than any other controllers
+	ja		.done						; (also takes care of the case where there are no other controllers)
 
 ;
@@ -371,6 +403,5 @@
 	rep	movsb
 
-	mov		di, si						; move up all the idevars below the serial, by one slot
-	sub		di, IDEVARS_size
+	lea		di, [si-IDEVARS_size]		; move up all the idevars below the serial, by one slot
 
 	mov		cx, ax						; restore end pointer of list, subtract off end of serial idevars
@@ -387,8 +418,8 @@
 	mov		cx, IDEVARS_size
 	; di is already at last IDEVARS position
-	
+
 	rep	movsb
 
-	add		sp, IDEVARS_size			
+	add		sp, IDEVARS_size
 
 	push	es
@@ -396,5 +427,5 @@
 
 	mov		dh, 1						; set flag that we have done a relocation
-	
+
 	jmp		.outerLoop
 
@@ -407,8 +438,8 @@
 	test	dh, dh
 	jz		.noWorkDone
-		
+
 	mov		dx, g_szSerialMoved
 	call	Dialogs_DisplayNotificationFromCSDX
 
-.noWorkDone:		
+.noWorkDone:
 	ret
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 379)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 380)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,11 +10,11 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
-;		
+;
 
 ; Section containing initialized data
@@ -71,5 +71,5 @@
 g_szItemMainConfigure:	db	"Configure XTIDE Universal BIOS",NULL
 g_szItemMainFlash:		db	"Flash EEPROM",NULL
-g_szItemMainSave:		db	"Save BIOS back to original file",NULL		
+g_szItemMainSave:		db	"Save BIOS back to original file",NULL
 g_szItemMainLicense:	db  "Copyright and License Information",NULL
 g_szItemMainHomePage:	db  "Web Links",NULL
@@ -92,9 +92,10 @@
 g_szNfoMainFlash:		db	"Flash loaded BIOS image to EEPROM.",NULL
 g_szNfoMainSave:		db	"Save BIOS changes back to original file from which it was loaded.",NULL
-g_szNfoMainLicense:		db	"XTIDE Universal BIOS and XTIDECFG Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team. Released under GNU GPL v2, with ABSOLUTELY NO WARRANTY. Press ENTER for more details...",NULL
+g_szNfoMainLicense:		db	"XTIDE Universal BIOS and XTIDECFG Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team."
+						db	" Released under GNU GPL v2, with ABSOLUTELY NO WARRANTY. Press ENTER for more details...",NULL
 g_szNfoMainHomePage:	db	"Visit http://code.google.com/p/ xtideuniversalbios (home page) and http://vintage-computer.com/ vcforum (support)",NULL
 
-g_szHelpMainLicense:	incbin	"Main_License.txt" 
-						db	NULL		
+g_szHelpMainLicense:	incbin	"Main_License.txt"
+						db	NULL
 
 ; Strings for XTIDE Universal BIOS configuration menu
@@ -108,8 +109,10 @@
 g_szItemCfgStealSize:	db	"kiB to steal from RAM",NULL
 g_szItemCfgIdeCnt:		db	"IDE controllers",NULL
+g_szItemCfgIdleTimeout:	db	"Power Management",NULL
 
 g_szDlgCfgFullMode:		db	"Enable full operating mode?",NULL
 g_szDlgCfgStealSize:	db	"How many kiB of base memory to steal for XTIDE Universal BIOS variables (1...255)?",NULL
 g_szDlgCfgIdeCnt:		db	"How many IDE controllers to manage (1...4)?",NULL
+g_szDlgCfgIdleTimeout:	db	"Select the amount of time before idling drives should enter standby mode.",NULL
 
 g_szNfoCfgIde:			db	"IDE controller and drive configuration.",NULL
@@ -118,6 +121,8 @@
 g_szNfoCfgStealSize:	db	"How many kiB's to steal from Conventional memory for XTIDE Universal BIOS variables.",NULL
 g_szNfoCfgIdeCnt:		db	"Number of IDE controllers to manage.",NULL
-
-g_szSerialMoved:		db  "A Serial Controller has been moved to the end of the Controller list. No further action is required. Serial Controllers must be placed at the end of the list.",NULL
+g_szNfoCfgIdleTimeout:	db	"Enable Power Management to set the harddrive(s) to spin down after idling a certain amount of time.",NULL
+
+g_szSerialMoved:		db  "A Serial Controller has been moved to the end of the Controller list."
+						db	" No further action is required. Serial Controllers must be placed at the end of the list.",NULL
 
 g_szHelpCfgFullMode:	incbin	"Configuration_FullMode.txt"
@@ -125,4 +130,60 @@
 g_szHelpCfgStealSize:	incbin	"Configuration_StealSize.txt"
 						db	NULL
+g_szHelpCfgIdleTimeout:	db	"This option enables the standby timer for all harddrives handled by XTIDE Universal BIOS,"
+						db	" allowing the drives to spin down after idling the selected amount of time."
+						db	" Note that this does not work with old drives that lack the Power Management feature set."
+						db	" Also note that timeouts less than 5 minutes may cause unnecessary wear on the drives and is not recommended"
+						db	" (use for compatibility testing only).",NULL
+g_szMultichoiceIdleTimeout:
+							db	"Disabled",LF
+							db	"1 m",LF
+							db	"2 m",LF
+							db	"3 m",LF
+							db	"4 m",LF
+							db	"5 m",LF
+							db	"6 m",LF
+							db	"7 m",LF
+							db	"8 m",LF
+							db	"9 m",LF
+							db	"10 m",LF
+							db	"11 m",LF
+							db	"12 m",LF
+							db	"13 m",LF
+							db	"14 m",LF
+							db	"15 m",LF
+							db	"16 m",LF
+							db	"17 m",LF
+							db	"18 m",LF
+							db	"19 m",LF
+							db	"20 m",LF
+							db	"30 m",LF
+							db	"1 h",LF
+							db	"1 h 30 m",LF
+g_szIdleTimeoutChoice24:	db	"2 h",NULL
+
+g_szIdleTimeoutChoice0:		db	"Disabled",NULL
+g_szIdleTimeoutChoice1:		db	"1 m",NULL
+g_szIdleTimeoutChoice2:		db	"2 m",NULL
+g_szIdleTimeoutChoice3:		db	"3 m",NULL
+g_szIdleTimeoutChoice4:		db	"4 m",NULL
+g_szIdleTimeoutChoice5:		db	"5 m",NULL
+g_szIdleTimeoutChoice6:		db	"6 m",NULL
+g_szIdleTimeoutChoice7:		db	"7 m",NULL
+g_szIdleTimeoutChoice8:		db	"8 m",NULL
+g_szIdleTimeoutChoice9:		db	"9 m",NULL
+g_szIdleTimeoutChoice10:	db	"10 m",NULL
+g_szIdleTimeoutChoice11:	db	"11 m",NULL
+g_szIdleTimeoutChoice12:	db	"12 m",NULL
+g_szIdleTimeoutChoice13:	db	"13 m",NULL
+g_szIdleTimeoutChoice14:	db	"14 m",NULL
+g_szIdleTimeoutChoice15:	db	"15 m",NULL
+g_szIdleTimeoutChoice16:	db	"16 m",NULL
+g_szIdleTimeoutChoice17:	db	"17 m",NULL
+g_szIdleTimeoutChoice18:	db	"18 m",NULL
+g_szIdleTimeoutChoice19:	db	"19 m",NULL
+g_szIdleTimeoutChoice20:	db	"20 m",NULL
+g_szIdleTimeoutChoice21:	db	"30 m",NULL
+g_szIdleTimeoutChoice22:	db	"1 h",NULL
+g_szIdleTimeoutChoice23:	db	"1 h 30 m",NULL
 
 ; Strings for IDE Controller menu
@@ -139,6 +200,6 @@
 g_szItemSerialPort:		db	"COM Port I/O address",NULL
 
-g_szItemIdeSerialComPort:		db		"COM port",NULL
-g_szItemIdeSerialBaudRate:		db		"Baud rate",NULL
+g_szItemIdeSerialComPort:	db	"COM port",NULL
+g_szItemIdeSerialBaudRate:	db	"Baud rate",NULL
 
 g_szDlgDevice:			db	"Select controller type.",NULL
@@ -157,5 +218,6 @@
 g_szNfoIdeIRQ:			db	"IRQ channel to use.",NULL
 g_szNfoIdeSerialCOM:	db	"Select a COM port by number.",NULL
-g_szNfoIdeSerialBaud:	db	"Select the COM port's Baud Rate. The server must match this speed. Note that UART clock multipliers may impact the actual speed.",NULL
+g_szNfoIdeSerialBaud:	db	"Select the COM port's Baud Rate. The server must match this speed."
+						db	" Note that UART clock multipliers may impact the actual speed.",NULL
 g_szNfoIdeSerialPort:	db	"Select a COM port by custom I/O port address. Any address is valid up to 3f8h, but must be on an 8-byte boundary.",NULL
 
@@ -279,5 +341,5 @@
 g_szHelpDrvUserLBA:		incbin	"Drive_UserLBA.txt"
 						db	NULL
-						
+
 g_szMultichoiseWrCache:	db	"Drive Default",LF
 						db	"Disable Write Cache",LF
@@ -311,5 +373,6 @@
 g_szNfoBootFloppyDrvs:	db	"Number of Floppy Drives to display on boot menu.",NULL
 g_szNfoBootSwap:		db	"Drive Number Translation (swap first drive with selected).",NULL
-g_szNfoSerialDetect:	db	"Scans all standard COM ports for serial drives. This can also be invoked by holding down ALT at the end of normal drive detection.",NULL
+g_szNfoSerialDetect:	db	"Scans all standard COM ports for serial drives."
+						db	" This can also be invoked by holding down ALT at the end of normal drive detection.",NULL
 
 g_szHelpBootTimeout:	incbin	"Bootmenu_Timeout.txt"
@@ -415,7 +478,7 @@
 g_szValueFlash32bytes:	db	"32 bytes",NULL
 
-g_szSelectionTimeout:	db		DOUBLE_BOTTOM_LEFT_CORNER,DOUBLE_LEFT_HORIZONTAL_TO_SINGLE_VERTICAL,"%ASelection in %2u s",NULL
-
-g_szDashForZero:		db		"- ",NULL
+g_szSelectionTimeout:	db	DOUBLE_BOTTOM_LEFT_CORNER,DOUBLE_LEFT_HORIZONTAL_TO_SINGLE_VERTICAL,"%ASelection in %2u s",NULL
+
+g_szDashForZero:		db	"- ",NULL
 
 g_szValueUnknownError:	db	"Error!",NULL